// autor: Jan Hřebec

// snímač vzdálenosti (není to moc hezký kód)

#include "mbed.h"

#define SAMPLE 200

DigitalOut led(PA_3);  //pin9  LED
DigitalOut buzz(PA_4); //pin10 reproduktor
AnalogIn foto(PA_5);   //pin11 vstup fototranzistoru

int main()
{
    float prumerBez[SAMPLE];
    float prumerS[SAMPLE];
    int ukazatelBez = 0;
    int ukazatelS = 0;
    int cas = 0;
    int perioda = 0;
    while(1) {               //hlavní smyčka programu
        wait_us(10);
        if(cas % 200 == 0){ //blikani ledkou
            led = 0;
        }
        if(cas % 200 == 100){
            led = 1;
        }
        if(cas%10 == 5){ //zapis hodnoty do prumeru
            if(cas % 200 < 100){
                prumerBez[ukazatelBez] = foto;
                ukazatelBez = (ukazatelBez + 1) % SAMPLE;    
            } else {
                prumerS[ukazatelS] = foto;
                ukazatelS = (ukazatelS + 1) % SAMPLE;
            }
        }
        if(perioda == 0){ //slabý signál, reproduktor nehraje
            buzz = 0;
        } else { // reproduktor hraje
            if(cas % perioda > perioda / 2){
                buzz = 0;
            } else {
                buzz = 1;
            }
        }
        if(cas % 200 == 0){ // aktualizace frekvence reproduktoru
            float prumer = 0;
            for (int i = 0; i < SAMPLE; i++){
                prumer += prumerS[i];
                prumer -= prumerBez[i];
            }
            if (prumer > 0.5){
                prumer = sqrt(prumer + 1) * 10;
                perioda = (float)1000 / prumer;
            } else {
                perioda = 0;
            }
        }
        cas++;
    }
}
